using System;
using System.Collections.Generic;
using System.Text;
using SCFiler2.Util;

namespace SCFiler2.Operation {
	public abstract class Action {
		/// <summary>
		/// ANV̕
		/// </summary>
		public enum ActionType {
			FileOperation,
			View,
			Application,
			Move,
			Tool,
		}

		/// <summary>
		/// type\邽߂̕Ԃ
		/// </summary>
		/// <param name="type"></param>
		/// <returns></returns>
		static public string GetTypeString(ActionType type) {
			switch (type) {
				case ActionType.Application:
					return "AvP[V";
				case ActionType.FileOperation:
					return "t@C";
				case ActionType.Move:
					return "ړ";
				case ActionType.View:
					return "\";
				case ActionType.Tool:
					return "c[";
				default:
					return "";
			}
		}

		/// <summary>
		/// ݂̃CX^XActionType\Ԃ
		/// </summary>
		public string TypeString {
			get { return GetTypeString(this.Type); }
		}


		/// <summary>
		/// tH[ȂǂŃANVʂ邽߂ɕ\镶
		/// </summary>
		abstract public string DisplayString { get;}

		/// <summary>
		/// ANV̎s\bhBANVsƂ͂Ăяo
		/// </summary>
		abstract public void Execute();

		/// <summary>
		/// ANV̕
		/// </summary>
		abstract public ActionType Type { get;}

		public override string ToString() {
			return this.DisplayString;
		}
	}
}
